import * as i0 from '@angular/core';
import { input, output, viewChild, Component, inject, signal, HostBinding, Injectable, effect } from '@angular/core';
import * as i2 from '@angular/forms';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import * as i1$1 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i1 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i3 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i2$1 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i4 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import * as i2$2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i5 from '@angular/material/core';
import * as i1$2 from '@angular/material/dialog';
import { MatDialogRef, MAT_DIALOG_DATA, MatDialogModule } from '@angular/material/dialog';
import { DomSanitizer } from '@angular/platform-browser';
import * as i3$1 from '@angular/material/progress-spinner';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import * as i1$3 from '@angular/material/progress-bar';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import * as i9 from '@angular/material/badge';
import { MatBadgeModule } from '@angular/material/badge';
import * as i7 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i6 from '@angular/material/sort';
import { MatSort, MatSortModule } from '@angular/material/sort';
import * as i4$1 from '@angular/material/table';
import { MatTableDataSource, MatTableModule } from '@angular/material/table';
import * as i10 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import * as i5$1 from '@angular/material/paginator';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import { Subject, debounceTime } from 'rxjs';
import { SelectionModel } from '@angular/cdk/collections';
import * as i11 from '@angular/material/menu';
import { MatMenuModule } from '@angular/material/menu';
import * as i1$4 from 'ngx-quill';
import { QuillModule } from 'ngx-quill';
import * as i1$5 from '@angular/material/button-toggle';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import 'quill/dist/quill.snow.css';

const includeNoSensible = (cadena, query) => {
    const nomalizadoCadena = cadena
        .toLowerCase()
        .normalize('NFD')
        .replace(/[\u0300-\u036f]/g, '');
    const nomalizadoQuery = query
        .toLowerCase()
        .normalize('NFD')
        .replace(/[\u0300-\u036f]/g, '');
    return nomalizadoCadena.includes(nomalizadoQuery);
};
const base64ToUtf8 = (str) => {
    return decodeURIComponent(atob(str)
        .split('')
        .map(function (c) {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    })
        .join(''));
};

class EiffageBasicSelect {
    options = input.required();
    selectedOptions = input();
    label = input.required();
    control = input.required();
    placeholder = input('');
    multiple = input(false);
    clearable = input(false);
    error = input('');
    disabled = input(false);
    selectionChange = output();
    resetInput = output();
    searchInput = viewChild.required('searchInput');
    ngOnInit() {
        if (this.disabled())
            this.control().disable();
    }
    clearInput() {
        this.searchInput().nativeElement.value = '';
        this.searchInput().nativeElement.focus();
    }
    numberVisibleOptions() {
        const query = this.searchInput().nativeElement.value || '';
        const visibleOptions = this.options().filter(option => includeNoSensible(option.label, query));
        return visibleOptions.length;
    }
    includeInFilter(option) {
        const query = this.searchInput().nativeElement.value || '';
        return includeNoSensible(option.label, query);
    }
    onClearSelect() {
        this.control().setValue(this.multiple() ? [] : null);
        this.resetInput.emit();
    }
    onSelectionChange(value) {
        this.selectionChange.emit(value);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageBasicSelect, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: EiffageBasicSelect, isStandalone: true, selector: "eiffage-basic-select", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: true, transformFunction: null }, selectedOptions: { classPropertyName: "selectedOptions", publicName: "selectedOptions", isSignal: true, isRequired: false, transformFunction: null }, label: { classPropertyName: "label", publicName: "label", isSignal: true, isRequired: true, transformFunction: null }, control: { classPropertyName: "control", publicName: "control", isSignal: true, isRequired: true, transformFunction: null }, placeholder: { classPropertyName: "placeholder", publicName: "placeholder", isSignal: true, isRequired: false, transformFunction: null }, multiple: { classPropertyName: "multiple", publicName: "multiple", isSignal: true, isRequired: false, transformFunction: null }, clearable: { classPropertyName: "clearable", publicName: "clearable", isSignal: true, isRequired: false, transformFunction: null }, error: { classPropertyName: "error", publicName: "error", isSignal: true, isRequired: false, transformFunction: null }, disabled: { classPropertyName: "disabled", publicName: "disabled", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { selectionChange: "selectionChange", resetInput: "resetInput" }, viewQueries: [{ propertyName: "searchInput", first: true, predicate: ["searchInput"], descendants: true, isSignal: true }], ngImport: i0, template: "<mat-form-field appearance=\"outline\">\r\n    <mat-label>{{ label() }}</mat-label>\r\n    <mat-select [formControl]=\"control()\" (selectionChange)=\"onSelectionChange($event.value)\" [multiple]=\"multiple()\" [placeholder]=\"placeholder()\">\r\n        <div class=\"searchFilter\">\r\n            <mat-icon class=\"searchIcon\">search</mat-icon>\r\n            @if(searchInput.value.length === 0) {\r\n                <span>Buscar...</span>\r\n            }\r\n            <input matInput #searchInput type=\"text\" (keydown)=\"$event.stopPropagation()\" /> \r\n            @if (searchInput.value.length > 0) {\r\n                <button mat-icon-button (click)=\"clearInput()\"><mat-icon>close</mat-icon></button>\r\n            }\r\n        </div>\r\n        @if(numberVisibleOptions() === 0) {\r\n            <p class=\"noResults\">No se han encontrado resultados...</p>\r\n        }\r\n        @for (option of options(); track option) {\r\n            <mat-option [value]=\"option.value\" [style]=\"{ display: includeInFilter(option) ? 'flex' : 'none' }\">{{ option.label }}</mat-option>\r\n        }\r\n    </mat-select>\r\n    @if(clearable() && control().value) {\r\n        <mat-icon matSuffix (click)=\"onClearSelect(); $event.stopPropagation()\">close</mat-icon>\r\n    }\r\n    <mat-error>{{ error() }}</mat-error>\r\n</mat-form-field>", styles: ["mat-form-field{width:100%;min-width:240px}.searchFilter{display:flex;align-items:center;position:sticky;top:-8px;height:48px;width:100%;background:#fff;z-index:10;border-bottom:1px solid var(--accent-3)}.searchFilter input{height:48px;padding:0 48px;width:calc(100% - 96px);position:absolute;top:0;left:0}.searchFilter .searchIcon{color:var(--accent-3);position:absolute;top:0;left:0;height:48px;width:48px;display:flex;align-items:center;justify-content:center}.searchFilter span{line-height:48px;position:absolute;left:48px;color:gray}button{position:absolute;right:0}.noResults{color:gray;margin-top:5px;padding:0 16px;width:calc(100% - 32px)}@media screen and (max-width: 768px){mat-form-field{width:100%;min-width:unset}}\n"], dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i2$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "component", type: i1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i1.MatLabel, selector: "mat-label" }, { kind: "directive", type: i1.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatSelectModule }, { kind: "component", type: i4.MatSelect, selector: "mat-select", inputs: ["aria-describedby", "panelClass", "disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator", "placeholder", "required", "multiple", "disableOptionCentering", "compareWith", "value", "aria-label", "aria-labelledby", "errorStateMatcher", "typeaheadDebounceInterval", "sortComparator", "id", "panelWidth", "canSelectNullableOptions"], outputs: ["openedChange", "opened", "closed", "selectionChange", "valueChange"], exportAs: ["matSelect"] }, { kind: "component", type: i5.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i1$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "ngmodule", type: CommonModule }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageBasicSelect, decorators: [{
            type: Component,
            args: [{ selector: 'eiffage-basic-select', imports: [
                        ReactiveFormsModule,
                        MatInputModule,
                        MatSelectModule,
                        MatIconModule,
                        MatButtonModule,
                        MatFormFieldModule,
                        CommonModule
                    ], template: "<mat-form-field appearance=\"outline\">\r\n    <mat-label>{{ label() }}</mat-label>\r\n    <mat-select [formControl]=\"control()\" (selectionChange)=\"onSelectionChange($event.value)\" [multiple]=\"multiple()\" [placeholder]=\"placeholder()\">\r\n        <div class=\"searchFilter\">\r\n            <mat-icon class=\"searchIcon\">search</mat-icon>\r\n            @if(searchInput.value.length === 0) {\r\n                <span>Buscar...</span>\r\n            }\r\n            <input matInput #searchInput type=\"text\" (keydown)=\"$event.stopPropagation()\" /> \r\n            @if (searchInput.value.length > 0) {\r\n                <button mat-icon-button (click)=\"clearInput()\"><mat-icon>close</mat-icon></button>\r\n            }\r\n        </div>\r\n        @if(numberVisibleOptions() === 0) {\r\n            <p class=\"noResults\">No se han encontrado resultados...</p>\r\n        }\r\n        @for (option of options(); track option) {\r\n            <mat-option [value]=\"option.value\" [style]=\"{ display: includeInFilter(option) ? 'flex' : 'none' }\">{{ option.label }}</mat-option>\r\n        }\r\n    </mat-select>\r\n    @if(clearable() && control().value) {\r\n        <mat-icon matSuffix (click)=\"onClearSelect(); $event.stopPropagation()\">close</mat-icon>\r\n    }\r\n    <mat-error>{{ error() }}</mat-error>\r\n</mat-form-field>", styles: ["mat-form-field{width:100%;min-width:240px}.searchFilter{display:flex;align-items:center;position:sticky;top:-8px;height:48px;width:100%;background:#fff;z-index:10;border-bottom:1px solid var(--accent-3)}.searchFilter input{height:48px;padding:0 48px;width:calc(100% - 96px);position:absolute;top:0;left:0}.searchFilter .searchIcon{color:var(--accent-3);position:absolute;top:0;left:0;height:48px;width:48px;display:flex;align-items:center;justify-content:center}.searchFilter span{line-height:48px;position:absolute;left:48px;color:gray}button{position:absolute;right:0}.noResults{color:gray;margin-top:5px;padding:0 16px;width:calc(100% - 32px)}@media screen and (max-width: 768px){mat-form-field{width:100%;min-width:unset}}\n"] }]
        }] });

class EiffageConfirmDialog {
    //dependency injection
    _dialogRef = inject((MatDialogRef));
    data = inject(MAT_DIALOG_DATA);
    onConfirmClick() {
        this._dialogRef.close(true);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageConfirmDialog, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.0.5", type: EiffageConfirmDialog, isStandalone: true, selector: "eiffage-confirm-dialog", ngImport: i0, template: "<h2 mat-dialog-title>{{ data.title }}</h2>\r\n<mat-dialog-content>\r\n    <p [innerHTML]=\"data.messageHtml\"></p>\r\n</mat-dialog-content>\r\n<mat-dialog-actions align=\"end\">\r\n    <button mat-stroked-button mat-dialog-close type=\"button\">{{ data.cancelText ?? 'Cancelar' }}</button>\r\n    <button mat-flat-button color=\"primary\" (click)=\"onConfirmClick()\">{{ data.confirmText ?? 'Aceptar' }}</button>\r\n</mat-dialog-actions>\r\n", styles: [""], dependencies: [{ kind: "ngmodule", type: MatDialogModule }, { kind: "directive", type: i1$2.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }, { kind: "directive", type: i1$2.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: i1$2.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "directive", type: i1$2.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i1$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageConfirmDialog, decorators: [{
            type: Component,
            args: [{ selector: 'eiffage-confirm-dialog', imports: [MatDialogModule, MatButtonModule], template: "<h2 mat-dialog-title>{{ data.title }}</h2>\r\n<mat-dialog-content>\r\n    <p [innerHTML]=\"data.messageHtml\"></p>\r\n</mat-dialog-content>\r\n<mat-dialog-actions align=\"end\">\r\n    <button mat-stroked-button mat-dialog-close type=\"button\">{{ data.cancelText ?? 'Cancelar' }}</button>\r\n    <button mat-flat-button color=\"primary\" (click)=\"onConfirmClick()\">{{ data.confirmText ?? 'Aceptar' }}</button>\r\n</mat-dialog-actions>\r\n" }]
        }] });

class EiffageInfoDialog {
    //dependencies injection
    _sanitizer = inject(DomSanitizer);
    _data = inject(MAT_DIALOG_DATA);
    get data() {
        return this._data;
    }
    get messageHtml() {
        return this._sanitizer.bypassSecurityTrustHtml(this._data.messageHtml ?? '');
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageInfoDialog, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: EiffageInfoDialog, isStandalone: true, selector: "lib-info-dialog", ngImport: i0, template: "<div class=\"container\">\r\n    <div class=\"header\">\r\n        <h2 mat-dialog-title>{{ data.title }}</h2>\r\n        @if(data.icon) {\r\n            <mat-icon [style]=\"{ color: data.iconColor }\">{{ data.icon }}</mat-icon>\r\n        }\r\n    </div>\r\n    <mat-dialog-content>\r\n        <p [innerHTML]=\"messageHtml\"></p>\r\n    </mat-dialog-content>\r\n    <mat-dialog-actions align=\"end\">\r\n        <button mat-flat-button color=\"primary\" mat-dialog-close>{{ data.confirmText ?? 'Aceptar' }}</button>\r\n    </mat-dialog-actions>\r\n</div>", styles: [".container{min-width:220px}.header{padding:20px 24px 0;display:flex;align-items:center;justify-content:space-between;gap:12px}h2{margin:0;padding:0;font-weight:500!important}mat-icon{min-width:28px;min-height:28px;font-size:28px}\n"], dependencies: [{ kind: "ngmodule", type: MatDialogModule }, { kind: "directive", type: i1$2.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }, { kind: "directive", type: i1$2.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: i1$2.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "directive", type: i1$2.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i1$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageInfoDialog, decorators: [{
            type: Component,
            args: [{ selector: 'lib-info-dialog', imports: [MatDialogModule, MatButtonModule, MatIconModule], template: "<div class=\"container\">\r\n    <div class=\"header\">\r\n        <h2 mat-dialog-title>{{ data.title }}</h2>\r\n        @if(data.icon) {\r\n            <mat-icon [style]=\"{ color: data.iconColor }\">{{ data.icon }}</mat-icon>\r\n        }\r\n    </div>\r\n    <mat-dialog-content>\r\n        <p [innerHTML]=\"messageHtml\"></p>\r\n    </mat-dialog-content>\r\n    <mat-dialog-actions align=\"end\">\r\n        <button mat-flat-button color=\"primary\" mat-dialog-close>{{ data.confirmText ?? 'Aceptar' }}</button>\r\n    </mat-dialog-actions>\r\n</div>", styles: [".container{min-width:220px}.header{padding:20px 24px 0;display:flex;align-items:center;justify-content:space-between;gap:12px}h2{margin:0;padding:0;font-weight:500!important}mat-icon{min-width:28px;min-height:28px;font-size:28px}\n"] }]
        }] });

class EiffageFilter {
    value = input(); // valor del input
    _query = signal(''); // valor del input
    placeholder = input.required(); // texto que aparece en el placeholder
    width = input('width100'); // ancho del componente
    queryChange = output(); // se emite cuando el valor del input cambia
    keyEnter = output(); // se emite cuando se presiona la tecla enter
    get hostClass() {
        return this.width();
    }
    ngOnInit() {
        this._query.set(this.value() ?? '');
        this.queryChange.emit(this._query());
    }
    get query() {
        return this._query();
    }
    set query(value) {
        this._query.set(typeof value === 'string' ? value : '');
        this.queryChange.emit(this._query());
    }
    onKeyup(event) {
        this.query = event.target.value;
    }
    onKeyEnter() {
        this.keyEnter.emit();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageFilter, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "19.0.5", type: EiffageFilter, isStandalone: true, selector: "eiffage-filter", inputs: { value: { classPropertyName: "value", publicName: "value", isSignal: true, isRequired: false, transformFunction: null }, placeholder: { classPropertyName: "placeholder", publicName: "placeholder", isSignal: true, isRequired: true, transformFunction: null }, width: { classPropertyName: "width", publicName: "width", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { queryChange: "queryChange", keyEnter: "keyEnter" }, host: { properties: { "class": "this.hostClass" } }, ngImport: i0, template: "<mat-form-field class=\"filter\">\r\n    <mat-icon matPrefix class=\"lupa\">search</mat-icon>\r\n    <input\r\n      matInput\r\n      type=\"text\"\r\n      [value]=\"_query()\"\r\n      [placeholder]=\"placeholder()\"\r\n      (keyup)=\"onKeyup($event)\"\r\n      (keyup.enter)=\"onKeyEnter()\"\r\n    />\r\n    <button\r\n    [style]=\"{ visibility: _query() ? 'visible' : 'hidden' }\"\r\n    matSuffix\r\n    mat-icon-button\r\n    (click)=\"query = ''\"\r\n    >\r\n    <mat-icon>close</mat-icon>\r\n  </button>\r\n</mat-form-field>", styles: [":host{display:block;width:var(--component-width, 100%)}:host(.width33){--component-width: 33%}:host(.width50){--component-width: 50%}:host(.width66){--component-width: 66%}:host(.width100){--component-width: 100%}mat-form-field{width:100%}@media (max-width: 768px){.filter{width:100%!important}}\n"], dependencies: [{ kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i1.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i2$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i1$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: CommonModule }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageFilter, decorators: [{
            type: Component,
            args: [{ selector: 'eiffage-filter', imports: [
                        MatFormFieldModule,
                        MatInputModule,
                        MatButtonModule,
                        MatIconModule,
                        CommonModule,
                    ], template: "<mat-form-field class=\"filter\">\r\n    <mat-icon matPrefix class=\"lupa\">search</mat-icon>\r\n    <input\r\n      matInput\r\n      type=\"text\"\r\n      [value]=\"_query()\"\r\n      [placeholder]=\"placeholder()\"\r\n      (keyup)=\"onKeyup($event)\"\r\n      (keyup.enter)=\"onKeyEnter()\"\r\n    />\r\n    <button\r\n    [style]=\"{ visibility: _query() ? 'visible' : 'hidden' }\"\r\n    matSuffix\r\n    mat-icon-button\r\n    (click)=\"query = ''\"\r\n    >\r\n    <mat-icon>close</mat-icon>\r\n  </button>\r\n</mat-form-field>", styles: [":host{display:block;width:var(--component-width, 100%)}:host(.width33){--component-width: 33%}:host(.width50){--component-width: 50%}:host(.width66){--component-width: 66%}:host(.width100){--component-width: 100%}mat-form-field{width:100%}@media (max-width: 768px){.filter{width:100%!important}}\n"] }]
        }], propDecorators: { hostClass: [{
                type: HostBinding,
                args: ['class']
            }] } });

class EiffageLoadingButton {
    buttonType = input('raised'); //Tipo de botón
    loading = input.required(); //Indica si el botón está cargando
    loadingColor = input('#FFFFFF'); //Color del spinner de carga
    text = input.required(); //Texto del botón
    textColor = input('#000000'); //Color del texto
    disabledTextColor = input('#000000'); //Color del texto cuando está deshabilitado
    icon = input(); //Icono del botón si es tipo icon
    iconColor = input('#000000'); //Color del icono
    color = input('primary'); //Color del botón
    disabled = input(false); //Indica si el botón está deshabilitado
    type = input('button'); //Tipo de acción del botón
    onClick = output(); //Evento que se dispara al hacer click en el botón
    onButtonClick() {
        this.onClick.emit();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageLoadingButton, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: EiffageLoadingButton, isStandalone: true, selector: "eiffage-loading-button", inputs: { buttonType: { classPropertyName: "buttonType", publicName: "buttonType", isSignal: true, isRequired: false, transformFunction: null }, loading: { classPropertyName: "loading", publicName: "loading", isSignal: true, isRequired: true, transformFunction: null }, loadingColor: { classPropertyName: "loadingColor", publicName: "loadingColor", isSignal: true, isRequired: false, transformFunction: null }, text: { classPropertyName: "text", publicName: "text", isSignal: true, isRequired: true, transformFunction: null }, textColor: { classPropertyName: "textColor", publicName: "textColor", isSignal: true, isRequired: false, transformFunction: null }, disabledTextColor: { classPropertyName: "disabledTextColor", publicName: "disabledTextColor", isSignal: true, isRequired: false, transformFunction: null }, icon: { classPropertyName: "icon", publicName: "icon", isSignal: true, isRequired: false, transformFunction: null }, iconColor: { classPropertyName: "iconColor", publicName: "iconColor", isSignal: true, isRequired: false, transformFunction: null }, color: { classPropertyName: "color", publicName: "color", isSignal: true, isRequired: false, transformFunction: null }, disabled: { classPropertyName: "disabled", publicName: "disabled", isSignal: true, isRequired: false, transformFunction: null }, type: { classPropertyName: "type", publicName: "type", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { onClick: "onClick" }, ngImport: i0, template: "@switch(buttonType()) {\r\n    @case ('basic') {\r\n        <button mat-button [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n    @case ('raised') {\r\n        <button mat-raised-button [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n    @case ('stroked') {\r\n        <button mat-stroked-button [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n    @case ('flat') {\r\n        <button mat-flat-button [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n    @case ('icon') {\r\n        <button mat-icon-button [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-icon><mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\"></mat-spinner></mat-icon>\r\n            }\r\n            <mat-icon [style.color]=\"iconColor()\">{{ !loading() ? icon() : \"\" }}</mat-icon>\r\n        </button>\r\n    }\r\n    @case ('fab') {\r\n        <button mat-fab [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n    @case ('mini-fab') {\r\n        <button mat-mini-fab [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n}", styles: ["mat-spinner{top:50%;left:50%;position:absolute;width:18px!important;height:18px!important;transform:translate(-50%) translateY(-50%)}\n"], dependencies: [{ kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i1$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "component", type: i1$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "component", type: i1$1.MatMiniFabButton, selector: "button[mat-mini-fab]", exportAs: ["matButton"] }, { kind: "component", type: i1$1.MatFabButton, selector: "button[mat-fab]", inputs: ["extended"], exportAs: ["matButton"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatProgressSpinnerModule }, { kind: "component", type: i3$1.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "mode", "value", "diameter", "strokeWidth"], exportAs: ["matProgressSpinner"] }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2$2.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageLoadingButton, decorators: [{
            type: Component,
            args: [{ selector: 'eiffage-loading-button', imports: [
                        MatButtonModule,
                        MatIconModule,
                        MatProgressSpinnerModule,
                        CommonModule
                    ], template: "@switch(buttonType()) {\r\n    @case ('basic') {\r\n        <button mat-button [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n    @case ('raised') {\r\n        <button mat-raised-button [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n    @case ('stroked') {\r\n        <button mat-stroked-button [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n    @case ('flat') {\r\n        <button mat-flat-button [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n    @case ('icon') {\r\n        <button mat-icon-button [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-icon><mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\"></mat-spinner></mat-icon>\r\n            }\r\n            <mat-icon [style.color]=\"iconColor()\">{{ !loading() ? icon() : \"\" }}</mat-icon>\r\n        </button>\r\n    }\r\n    @case ('fab') {\r\n        <button mat-fab [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n    @case ('mini-fab') {\r\n        <button mat-mini-fab [color]=\"color()\" [type]=\"type()\" [disabled]=\"disabled()\" (click)=\"onButtonClick()\">\r\n            @if (loading()) {\r\n                <mat-spinner [style]=\"{ '--mdc-circular-progress-active-indicator-color': loadingColor() }\" />\r\n            }\r\n            <span [style.color]=\"textColor()\" [ngStyle]=\"{ 'color': disabled() ? disabledTextColor() : textColor(), 'visibility': loading() ? 'hidden' : 'visible' }\">{{ text() }}</span>\r\n        </button>\r\n    }\r\n}", styles: ["mat-spinner{top:50%;left:50%;position:absolute;width:18px!important;height:18px!important;transform:translate(-50%) translateY(-50%)}\n"] }]
        }] });

class EiffagePaginatedSelect {
    label = input.required(); // Label del select
    options$ = input.required(); // Observable que emite las opciones del select
    control = input.required(); // Control del formulario
    valueKey = input.required(); // Identificador unico de la opción
    labelKey = input.required(); // Función que devuelve el label de la opción
    placeholder = input(''); // Placeholder del select opcional
    multiple = input(false); // Si es un select multiple o no
    clearable = input(false); // Si se puede limpiar el select o no
    errors = input([]); // Error del control del formulario
    selectionChange = output();
    updateOptions = output();
    searchInput = viewChild.required('searchInput');
    subscriptionOptions;
    subscriptionValueChange;
    unduplicatedSelections = signal([]);
    filter = signal({ pageNumber: 1, pageSize: 10, q: '' });
    options = signal([]);
    total = signal(0);
    ngAfterViewInit() {
        this.initializeData();
    }
    ngOnDestroy() {
        this.subscriptionOptions.unsubscribe();
        this.subscriptionValueChange.unsubscribe();
    }
    initializeData() {
        this.subscriptionValueChange = this.control().valueChanges.subscribe({
            next: () => this.includeSelectedOptions()
        });
        this.subscriptionOptions = this.options$().subscribe({
            next: (paginatedDropdownOptions) => {
                if (this.filter().pageNumber === 1) {
                    this.options.set(paginatedDropdownOptions.options);
                }
                else {
                    this.options.update(options => [...options, ...paginatedDropdownOptions.options]);
                }
                this.total.set(paginatedDropdownOptions.total);
                this.includeSelectedOptions();
                this.control().updateValueAndValidity();
            },
        });
        this.updateOptions.emit(this.filter());
    }
    getValue(option) {
        return option[this.valueKey()];
    }
    getLabel(option) {
        return this.labelKey()(option);
    }
    openedChange(opened) {
        if (!opened) {
            this.clearInput();
        }
        else {
            this.searchInput().nativeElement.focus();
        }
    }
    clearInput() {
        this.searchInput().nativeElement.value = '';
        this.filter.update(filter => ({ ...filter, pageNumber: 1, q: '' }));
        this.searchInput().nativeElement.focus();
        this.updateOptions.emit(this.filter());
    }
    onClearSelect() {
        this.control().setValue(this.multiple() ? [] : null);
    }
    onSelectionChange(item) {
        this.selectionChange.emit(item);
    }
    onQueryChange() {
        this.filter.update(filter => ({ ...filter, pageNumber: 1, q: this.searchInput().nativeElement.value }));
        this.updateOptions.emit(this.filter());
    }
    onSeeMore() {
        this.filter.update(filter => ({ ...filter, pageNumber: filter.pageNumber + 1 }));
        this.updateOptions.emit(this.filter());
    }
    compareWith = (option, selected) => {
        if (!option || !selected)
            return false;
        return this.getValue(option) === this.getValue(selected);
    };
    getErrorMessage() {
        for (let error of this.errors()) {
            if (this.control().hasError(error.name)) {
                return error.message;
            }
        }
        return '';
    }
    includeSelectedOptions() {
        if (!this.control().value)
            return;
        const selections = Array.isArray(this.control().value) ? this.control().value : [this.control().value];
        const missingSelections = selections.filter((selectedOption) => !this.options().some(option => this.getValue(option) === this.getValue(selectedOption)));
        // Asegúrate de que las opciones seleccionadas estén siempre visibles
        if (missingSelections.length > 0) {
            this.options.update(options => [...options, ...missingSelections]);
        }
    }
    selectedInOptions() {
        if (!this.control().value)
            return false;
        return this.options().some((option) => {
            return option[this.valueKey()] === this.control().value[this.valueKey()];
        });
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffagePaginatedSelect, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: EiffagePaginatedSelect, isStandalone: true, selector: "eiffage-paginated-select", inputs: { label: { classPropertyName: "label", publicName: "label", isSignal: true, isRequired: true, transformFunction: null }, options$: { classPropertyName: "options$", publicName: "options$", isSignal: true, isRequired: true, transformFunction: null }, control: { classPropertyName: "control", publicName: "control", isSignal: true, isRequired: true, transformFunction: null }, valueKey: { classPropertyName: "valueKey", publicName: "valueKey", isSignal: true, isRequired: true, transformFunction: null }, labelKey: { classPropertyName: "labelKey", publicName: "labelKey", isSignal: true, isRequired: true, transformFunction: null }, placeholder: { classPropertyName: "placeholder", publicName: "placeholder", isSignal: true, isRequired: false, transformFunction: null }, multiple: { classPropertyName: "multiple", publicName: "multiple", isSignal: true, isRequired: false, transformFunction: null }, clearable: { classPropertyName: "clearable", publicName: "clearable", isSignal: true, isRequired: false, transformFunction: null }, errors: { classPropertyName: "errors", publicName: "errors", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { selectionChange: "selectionChange", updateOptions: "updateOptions" }, viewQueries: [{ propertyName: "searchInput", first: true, predicate: ["searchInput"], descendants: true, isSignal: true }], ngImport: i0, template: "<mat-form-field appearance=\"outline\">\r\n    <mat-label>{{ label() }}</mat-label>\r\n    <mat-select \r\n        [formControl]=\"control()\" \r\n        [multiple]=\"multiple()\" \r\n        [placeholder]=\"placeholder()\" \r\n        [compareWith]=\"compareWith\" \r\n        (selectionChange)=\"onSelectionChange($event.value)\" \r\n        (openedChange)=\"openedChange($event)\"\r\n    >\r\n        <div class=\"searchFilter\">\r\n            <mat-icon class=\"searchIcon\">search</mat-icon>\r\n            @if(searchInput.value.length === 0) {\r\n                <span>Buscar...</span>\r\n            }\r\n            <input matInput #searchInput type=\"text\" (keydown)=\"$event.stopPropagation()\" (input)=\"onQueryChange()\" /> \r\n            @if (searchInput.value.length > 0) {\r\n                <button mat-icon-button (click)=\"clearInput()\"><mat-icon>close</mat-icon></button>\r\n            }\r\n        </div>\r\n\r\n        @if(options().length === 0) {\r\n            <p class=\"noResults\">No se han encontrado resultados...</p>\r\n        }\r\n        @for (option of options(); track getValue(option)) {\r\n            <mat-option [value]=\"option\">{{ getLabel(option) }}</mat-option>\r\n        }\r\n        @for(unduplicatedSelection of unduplicatedSelections(); track getValue(unduplicatedSelection)) { \r\n            <mat-option [value]=\"unduplicatedSelections\" [style]=\"{ display: selectedInOptions() ? 'flex' : 'none' }\">{{ getLabel(unduplicatedSelection) }}</mat-option>\r\n        }\r\n        @if (filter().pageNumber * filter().pageSize < total()) {\r\n            <p class=\"seeMoreButton\" (click)=\"onSeeMore()\">Ver m\u00E1s</p>\r\n        }\r\n    </mat-select>\r\n    @if(clearable() && control().value) {\r\n        <mat-icon matSuffix (click)=\"onClearSelect(); $event.stopPropagation()\">close</mat-icon>\r\n    }\r\n    <mat-error>{{ getErrorMessage() }}</mat-error>\r\n</mat-form-field>", styles: ["mat-form-field{width:100%;min-width:300px}.searchFilter{display:flex;align-items:center;position:sticky;top:-8px;height:48px;width:100%;background:#fff;z-index:10;border-bottom:1px solid var(--accent-3)}.searchFilter input{height:48px;padding:0 48px;width:calc(100% - 96px);position:absolute;top:0;left:0}.searchFilter .searchIcon{color:var(--accent-3);position:absolute;top:0;left:0;height:48px;width:48px;display:flex;align-items:center;justify-content:center}.searchFilter span{line-height:48px;position:absolute;left:48px;color:gray}button{position:absolute;right:0}.noResults{color:gray;margin-top:5px;padding:0 16px;width:calc(100% - 32px)}.seeMoreButton{margin:0;padding:0 16px;width:calc(100% - 32px);cursor:pointer;line-height:48px;color:var(--primary);text-align:center;font-weight:500}.seeMoreButton:hover{background:#0000000a}@media screen and (max-width: 768px){mat-form-field{width:100%}}\n"], dependencies: [{ kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i1.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i1.MatLabel, selector: "mat-label" }, { kind: "directive", type: i1.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i1.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatSelectModule }, { kind: "component", type: i4.MatSelect, selector: "mat-select", inputs: ["aria-describedby", "panelClass", "disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator", "placeholder", "required", "multiple", "disableOptionCentering", "compareWith", "value", "aria-label", "aria-labelledby", "errorStateMatcher", "typeaheadDebounceInterval", "sortComparator", "id", "panelWidth", "canSelectNullableOptions"], outputs: ["openedChange", "opened", "closed", "selectionChange", "valueChange"], exportAs: ["matSelect"] }, { kind: "component", type: i5.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i2$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly", "disabledInteractive"], exportAs: ["matInput"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i1$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: CommonModule }, { kind: "ngmodule", type: FormsModule }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffagePaginatedSelect, decorators: [{
            type: Component,
            args: [{ selector: 'eiffage-paginated-select', imports: [
                        MatFormFieldModule,
                        MatSelectModule,
                        MatInputModule,
                        MatIconModule,
                        MatButtonModule,
                        ReactiveFormsModule,
                        CommonModule,
                        FormsModule,
                    ], template: "<mat-form-field appearance=\"outline\">\r\n    <mat-label>{{ label() }}</mat-label>\r\n    <mat-select \r\n        [formControl]=\"control()\" \r\n        [multiple]=\"multiple()\" \r\n        [placeholder]=\"placeholder()\" \r\n        [compareWith]=\"compareWith\" \r\n        (selectionChange)=\"onSelectionChange($event.value)\" \r\n        (openedChange)=\"openedChange($event)\"\r\n    >\r\n        <div class=\"searchFilter\">\r\n            <mat-icon class=\"searchIcon\">search</mat-icon>\r\n            @if(searchInput.value.length === 0) {\r\n                <span>Buscar...</span>\r\n            }\r\n            <input matInput #searchInput type=\"text\" (keydown)=\"$event.stopPropagation()\" (input)=\"onQueryChange()\" /> \r\n            @if (searchInput.value.length > 0) {\r\n                <button mat-icon-button (click)=\"clearInput()\"><mat-icon>close</mat-icon></button>\r\n            }\r\n        </div>\r\n\r\n        @if(options().length === 0) {\r\n            <p class=\"noResults\">No se han encontrado resultados...</p>\r\n        }\r\n        @for (option of options(); track getValue(option)) {\r\n            <mat-option [value]=\"option\">{{ getLabel(option) }}</mat-option>\r\n        }\r\n        @for(unduplicatedSelection of unduplicatedSelections(); track getValue(unduplicatedSelection)) { \r\n            <mat-option [value]=\"unduplicatedSelections\" [style]=\"{ display: selectedInOptions() ? 'flex' : 'none' }\">{{ getLabel(unduplicatedSelection) }}</mat-option>\r\n        }\r\n        @if (filter().pageNumber * filter().pageSize < total()) {\r\n            <p class=\"seeMoreButton\" (click)=\"onSeeMore()\">Ver m\u00E1s</p>\r\n        }\r\n    </mat-select>\r\n    @if(clearable() && control().value) {\r\n        <mat-icon matSuffix (click)=\"onClearSelect(); $event.stopPropagation()\">close</mat-icon>\r\n    }\r\n    <mat-error>{{ getErrorMessage() }}</mat-error>\r\n</mat-form-field>", styles: ["mat-form-field{width:100%;min-width:300px}.searchFilter{display:flex;align-items:center;position:sticky;top:-8px;height:48px;width:100%;background:#fff;z-index:10;border-bottom:1px solid var(--accent-3)}.searchFilter input{height:48px;padding:0 48px;width:calc(100% - 96px);position:absolute;top:0;left:0}.searchFilter .searchIcon{color:var(--accent-3);position:absolute;top:0;left:0;height:48px;width:48px;display:flex;align-items:center;justify-content:center}.searchFilter span{line-height:48px;position:absolute;left:48px;color:gray}button{position:absolute;right:0}.noResults{color:gray;margin-top:5px;padding:0 16px;width:calc(100% - 32px)}.seeMoreButton{margin:0;padding:0 16px;width:calc(100% - 32px);cursor:pointer;line-height:48px;color:var(--primary);text-align:center;font-weight:500}.seeMoreButton:hover{background:#0000000a}@media screen and (max-width: 768px){mat-form-field{width:100%}}\n"] }]
        }] });

var ActionButtonType;
(function (ActionButtonType) {
    ActionButtonType[ActionButtonType["ADD"] = 0] = "ADD";
    ActionButtonType[ActionButtonType["EDIT"] = 1] = "EDIT";
    ActionButtonType[ActionButtonType["DELETE"] = 2] = "DELETE";
    ActionButtonType[ActionButtonType["DETAILS"] = 3] = "DETAILS";
})(ActionButtonType || (ActionButtonType = {}));

class TableService {
    /**
     * Render cell methods
     * @param row
     * @param column
     */
    // This method is used to get the cell value
    getCellValue(row, key) {
        const splitKey = key.split('.');
        let value;
        if (splitKey.length > 1) {
            value = this.getNestedKey(row, splitKey);
        }
        else {
            value = row[key];
        }
        if (value == undefined || value == null || value == '') {
            return null;
        }
        return value;
    }
    // This method is used to get the nested value of the object
    getNestedValue(obj, key) {
        return key.split('.').reduce((o, k) => o && o[k], obj);
    }
    // This method is used to get the nested key of the object
    getNestedKey(row, splitKey) {
        let value = row;
        for (let i = 0; i < splitKey.length; i++) {
            value = value[splitKey[i]];
        }
        return value;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: TableService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: TableService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: TableService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }] });

class EiffagePaginatedTable {
    // dependencies injection
    _tableService = inject(TableService);
    tableData = input.required();
    tableConfig = input.required();
    isLoading = input.required();
    ActionButtonType = ActionButtonType;
    pageChangeEvent = output();
    filterEvent = output();
    selectionEvent = output();
    filterSubject = new Subject();
    add_action = null;
    details_action = null;
    edit_action = null;
    delete_action = null;
    displayedColumns = signal([]);
    dataSource = signal(new MatTableDataSource());
    selection = signal(new SelectionModel(true, []));
    selections = signal([]);
    sort = viewChild.required(MatSort);
    paginator = viewChild.required(MatPaginator);
    constructor() {
        effect(() => {
            this.dataSource().data = this.tableData();
            this.dataSource().sort = this.sort();
        });
    }
    ngOnInit() {
        this.initializeData();
    }
    ngOnDestroy() {
        this.filterSubject.unsubscribe();
    }
    initializeData() {
        this.displayedColumns.set(this.getDisplayedColumns());
        if (this.tableConfig().showFilter) {
            this.filterSubject
                .pipe(debounceTime(300))
                .subscribe((filteredValue) => this.filterEvent.emit(filteredValue));
        }
    }
    getDisplayedColumns() {
        let displayedColumns = this.tableConfig().tableColumns.map((column) => column.key);
        if (this.tableConfig().selection)
            displayedColumns.unshift('selection');
        const actions = this.tableConfig().actions || [];
        if (actions && actions.length > 0) {
            for (const action of actions) {
                switch (action.type) {
                    case ActionButtonType.ADD:
                        this.add_action = action;
                        break;
                    case ActionButtonType.DETAILS:
                        this.details_action = action;
                        break;
                    case ActionButtonType.EDIT:
                        this.edit_action = action;
                        break;
                    case ActionButtonType.DELETE:
                        this.delete_action = action;
                        break;
                }
            }
            displayedColumns.push('actions');
        }
        return displayedColumns;
    }
    // Filter
    applyFilter(filteredValue) {
        this.selection().clear();
        this.filterSubject.next(filteredValue);
    }
    // Paginator
    onPageChange(event) {
        this.selection().clear();
        this.pageChangeEvent.emit(event);
    }
    // Selection
    isRowSelected(row) {
        return this.selections().some((selected) => this.areRowsEqual(selected, row));
    }
    areRowsEqual(rowA, rowB) {
        // Compara propiedades significativas (ajusta según tus datos)
        return JSON.stringify(rowA) === JSON.stringify(rowB);
    }
    isAllSelected() {
        const visibleRows = this.dataSource().data;
        const selectableRows = visibleRows.filter((row) => !this.tableConfig().hideSelection?.(row));
        return selectableRows.every((row) => this.selections().some((selected) => this.areRowsEqual(selected, row)));
    }
    hasSomeSelected() {
        const visibleRows = this.dataSource().data;
        return visibleRows.some((row) => this.selections().some((selected) => this.areRowsEqual(selected, row)));
    }
    toggleAllRows() {
        const isAllSelected = this.isAllSelected();
        const visibleRows = this.dataSource().data;
        const selectableRows = visibleRows.filter((row) => !this.tableConfig().hideSelection?.(row));
        if (isAllSelected) {
            this.selection().clear();
            this.selections.set(this.selections().filter((row) => !selectableRows.some((visible) => this.areRowsEqual(visible, row))));
        }
        else {
            this.selection().select(...selectableRows);
            this.selections.update((selections) => [
                ...selections,
                ...selectableRows.filter((row) => !selections.some((selected) => this.areRowsEqual(selected, row))),
            ]);
        }
        this.onSelectionChange();
    }
    checkboxLabel(row) {
        if (!row) {
            return `${this.isAllSelected() ? 'deselect' : 'select'} all`;
        }
        return `${this.selection().isSelected(row) ? 'deselect' : 'select'} row ${this.dataSource().data.indexOf(row) + 1}`;
    }
    toggleRow(row) {
        const isSelected = this.isRowSelected(row);
        if (isSelected) {
            this.selection().deselect(row);
            this.selections.update((selections) => selections.filter((selected) => !this.areRowsEqual(selected, row)));
        }
        else {
            this.selection().select(row);
            this.selections.update((selections) => [...selections, row]);
        }
        this.onSelectionChange();
    }
    onSelectionChange() {
        this.selectionEvent.emit(this.selections());
    }
    clearSelections() {
        this.selection().clear();
        this.selections.set([]);
        this.onSelectionChange();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffagePaginatedTable, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: EiffagePaginatedTable, isStandalone: true, selector: "eiffage-paginated-table", inputs: { tableData: { classPropertyName: "tableData", publicName: "tableData", isSignal: true, isRequired: true, transformFunction: null }, tableConfig: { classPropertyName: "tableConfig", publicName: "tableConfig", isSignal: true, isRequired: true, transformFunction: null }, isLoading: { classPropertyName: "isLoading", publicName: "isLoading", isSignal: true, isRequired: true, transformFunction: null } }, outputs: { pageChangeEvent: "pageChangeEvent", filterEvent: "filterEvent", selectionEvent: "selectionEvent" }, viewQueries: [{ propertyName: "sort", first: true, predicate: MatSort, descendants: true, isSignal: true }, { propertyName: "paginator", first: true, predicate: MatPaginator, descendants: true, isSignal: true }], ngImport: i0, template: "@if(tableConfig().title) {\r\n    <h3 class=\"titleTable\">{{ tableConfig().title }}</h3>\r\n}\r\n<div class=\"filtersContainer\">\r\n    @if(tableConfig().showFilter) {\r\n        <eiffage-filter\r\n            #tableFilter\r\n            [value]=\"tableConfig().filterValue\"\r\n            (queryChange)=\"applyFilter($event)\"\r\n            [placeholder]=\"tableConfig().filterPlaceholder || 'Buscar...'\"\r\n            [width]=\"tableConfig().filterWidth || 'width100'\"\r\n        />\r\n        @if(selections().length > 0) {\r\n            <button mat-mini-fab matTooltip=\"Limpiar seleccionados\" (click)=\"clearSelections()\">\r\n                <mat-icon>cleaning_services</mat-icon>\r\n            </button>\r\n        }\r\n    }\r\n    <ng-content />\r\n</div>\r\n<div class=\"overflowTable\">\r\n  @if (isLoading()) {\r\n  <mat-progress-bar mode=\"indeterminate\"></mat-progress-bar>\r\n  }\r\n  <table mat-table class=\"mat-elevation-z8\" [dataSource]=\"dataSource()\" matSort>\r\n\r\n    <!-- Selection -->\r\n     @if(tableConfig().selection) {\r\n        <ng-container matColumnDef=\"selection\">\r\n            <th mat-header-cell *matHeaderCellDef>\r\n                <mat-checkbox (change)=\"$event ? toggleAllRows() : null\"\r\n                    [checked]=\"isAllSelected()\"\r\n                    [indeterminate]=\"hasSomeSelected() && !isAllSelected()\"\r\n                    [aria-label]=\"checkboxLabel()\">\r\n                </mat-checkbox>\r\n            </th>\r\n            <td mat-cell *matCellDef=\"let element\">\r\n                @if(!tableConfig().hideSelection?.(element)) {\r\n                    <mat-checkbox (click)=\"$event.stopPropagation()\"\r\n                        (change)=\"$event ? toggleRow(element) : null\"\r\n                        [checked]=\"isRowSelected(element)\"\r\n                        [aria-label]=\"checkboxLabel(element)\">  \r\n                    </mat-checkbox>\r\n                }\r\n            </td>\r\n        </ng-container>\r\n     }\r\n    \r\n    <!-- Columns -->\r\n    @for(column of tableConfig().tableColumns; track column.key) {\r\n        <ng-container [matColumnDef]=\"column.key\" [sticky]=\"column?.stickyStart\" [stickyEnd]=\"column?.stickyEnd\">\r\n            <!-- Header cell definition -->\r\n            @if(column?.isSortable) {\r\n                <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ column.displayedName }}</th>\r\n            } @else {\r\n                <th mat-header-cell *matHeaderCellDef>{{ column.displayedName }}</th>\r\n            }\r\n\r\n            <!-- Row cell definition -->\r\n            <!-- Button -->\r\n            @if(column?.button){\r\n                <td mat-cell *matCellDef=\"let element\">\r\n                    @if(column.button?.showButton && column.button?.showButton(element)) {\r\n                        @if(column.button?.icon && column.button?.text) {\r\n                            <!-- Icon Text Button -->\r\n                            <button mat-raised-button [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor }\" (click)=\"column.button?.onClick(element)\">\r\n                                <mat-icon [style]=\"{ color: column.button?.iconColor }\">{{ column.button?.icon }}</mat-icon>\r\n                                <span [style]=\"{ color: column.button?.textColor }\">{{ column.button?.text }}</span>\r\n                            </button>\r\n                        } @else if(column.button?.icon && !column.button?.text) {\r\n                            <!-- Icon Button -->\r\n                            <button mat-raised-button class=\"actionButton\" [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor, padding: '12px' }\" (click)=\"column.button?.onClick(element)\">\r\n                                <mat-icon [style]=\"{ color: column.button?.iconColor }\">{{ column.button?.icon }}</mat-icon>\r\n                            </button>\r\n                        } @else if(!column.button?.icon && column.button?.text) {\r\n                            <!-- Text Button -->\r\n                            <button mat-raised-button [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor }\" (click)=\"column.button?.onClick(element)\">\r\n                                <span [style]=\"{ color: column.button?.textColor }\">{{ column.button?.text }}</span>\r\n                            </button>\r\n                        }\r\n                    } @else if(!column.button?.showButton) {\r\n                        @if(column.button?.icon && column.button?.text) {\r\n                            <!-- Icon Text Button -->\r\n                            <button mat-raised-button [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor }\" (click)=\"column.button?.onClick(element)\">\r\n                                <mat-icon [style]=\"{ color: column.button?.iconColor }\">{{ column.button?.icon }}</mat-icon>\r\n                                <span [style]=\"{ color: column.button?.textColor }\">{{ column.button?.text }}</span>\r\n                            </button>\r\n                        } @else if(column.button?.icon && !column.button?.text) {\r\n                            <!-- Icon Button -->\r\n                            <button mat-icon-button [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor }\" (click)=\"column.button?.onClick(element)\">\r\n                                <mat-icon [style]=\"{ color: column.button?.iconColor }\">{{ column.button?.icon }}</mat-icon>\r\n                            </button>\r\n                        } @else if(!column.button?.icon && column.button?.text) {\r\n                            <!-- Text Button -->\r\n                            <button mat-raised-button [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor }\" (click)=\"column.button?.onClick(element)\">\r\n                                <span [style]=\"{ color: column.button?.textColor }\">{{ column.button?.text }}</span>\r\n                            </button>\r\n                        }\r\n                    }\r\n                    <!-- @if(column.button?.showButton(element)) {\r\n                    } -->\r\n                </td>\r\n            } @else if(column.render) {\r\n                <td mat-cell *matCellDef=\"let element\" [innerHTML]=\"column.render(element, _tableService.getCellValue(element, column.key))\"></td>\"\r\n            } @else if(column?.icon) {\r\n                <td mat-cell *matCellDef=\"let element\">\r\n                    <div class=\"iconContainer\">\r\n                        <mat-icon [matTooltip]=\"column?.icon(element)?.tooltip\" [matBadge]=\"column?.icon(element)?.badge?.text\" [matBadgeSize]=\"column?.icon(element)?.badge?.size ?? 'medium'\" [style]=\"{ background: column?.icon(element)?.bgColor, color: column?.icon(element)?.iconColor }\" aria-hidden=\"false\" aria-label=\"Badge\">{{ column?.icon(element)?.icon }}</mat-icon>\r\n                        &nbsp;&nbsp;\r\n                        <span [style]=\"{ color: column?.icon(element)?.textColor }\">{{ column?.icon(element)?.text }}</span>\r\n                    </div>\r\n                </td>\r\n            } @else if(column?.menu) {\r\n                <td mat-cell *matCellDef=\"let element\">\r\n                    <button mat-icon-button [matMenuTriggerFor]=\"menu\" aria-label=\"Example icon-button with a menu\">\r\n                        <mat-icon>more_vert</mat-icon>\r\n                    </button>\r\n                    <mat-menu #menu=\"matMenu\" [yPosition]=\"column.menu?.yPosition ?? 'below'\" [xPosition]=\"column.menu?.xPosition ?? 'after'\">\r\n                        @for(item of column.menu?.items; track item) {\r\n                            <button mat-menu-item (click)=\"item.onClick(element)\" [disabled]=\"item.disabled\">\r\n                                @if(item.icon) {\r\n                                    <mat-icon>{{ item.icon }}</mat-icon>\r\n                                }\r\n                                <span>{{ item.text(element) }}</span>\r\n                            </button>\r\n                        }\r\n                    </mat-menu>\r\n                </td>\r\n            } @else if(column.href) {\r\n                <td mat-cell *matCellDef=\"let element\">\r\n                    @if(column?.href(element)) {\r\n                        <a class=\"maxEmail\" [href]=\"'mailto:'+column?.href(element)\" [matTooltip]=\"column?.href(element)\">{{ column?.href(element) }}</a>\r\n                    } @else {\r\n                        <span>-</span>\r\n                    }\r\n                </td>\r\n            }\r\n            @else {\r\n                <td mat-cell *matCellDef=\"let element\">\r\n                    <span [class.empty]=\"!(_tableService.getCellValue(element, column.key))\">\r\n                        @switch(column?.pipe?.name) {\r\n                            @case('date') {\r\n                                {{ _tableService.getCellValue(element, column.key) | date: column.pipe?.options ?? 'dd/MM/yyyy' }}\r\n                            }\r\n                            @case ('number') {\r\n                                {{ _tableService.getCellValue(element, column.key) | number : column.pipe?.options ?? \"1.0-0\"}}\r\n                            }\r\n                            @case ('currency') {\r\n                                {{ _tableService.getCellValue(element, column.key) | currency : column.pipe?.options ?? \"USD\"}}\r\n                            }\r\n                            @case ('json') {\r\n                                {{ _tableService.getCellValue(element, column.key) | json }}\r\n                            }\r\n                            @case ('lowercase') {\r\n                                {{ _tableService.getCellValue(element, column.key) | lowercase }}\r\n                            }\r\n                            @case ('uppercase') {\r\n                                {{ _tableService.getCellValue(element, column.key) | uppercase }}\r\n                            }\r\n                            @case ('titlecase') {\r\n                                {{ _tableService.getCellValue(element, column.key) | titlecase }}\r\n                            }\r\n                            @case ('percent') {\r\n                                {{ _tableService.getCellValue(element, column.key) | percent : column.pipe?.options ?? \"1.0-0\"}}\r\n                            }\r\n                            @default {\r\n                                {{ _tableService.getCellValue(element, column.key) ?? '-' }}\r\n                            }\r\n                        }\r\n                    </span>\r\n                </td>\r\n            }\r\n        </ng-container>\r\n    }\r\n\r\n    <!-- Actions -->\r\n    @if(add_action || details_action || edit_action || delete_action) {\r\n        <ng-container matColumnDef=\"actions\" [stickyEnd]=\"true\">\r\n            <th mat-header-cell *matHeaderCellDef>\r\n                @if(add_action) {\r\n                    <button mat-icon-button matTooltip=\"A\u00F1adir\" [style]=\"{color: '#4CAF50'}\" (click)=\"add_action.onClick()\">\r\n                        <mat-icon>add_circle</mat-icon>\r\n                    </button>\r\n                }\r\n            </th>\r\n            <td mat-cell *matCellDef=\"let element\">\r\n                <div class=\"actionsContainer\">\r\n                    @if(details_action) {\r\n                        <button mat-raised-button class=\"actionButton\" matTooltip=\"Ver detalle\" [style]=\"{color: '#005cbb', padding: '12px'}\" (click)=\"details_action.onClick(element)\">\r\n                            <mat-icon>search</mat-icon>\r\n                        </button>\r\n                    }\r\n                    @if(edit_action) {\r\n                        <button mat-raised-button class=\"actionButton\" matTooltip=\"Editar\" [style]=\"{color: '#FBC02D', padding: '12px'}\" (click)=\"edit_action.onClick(element)\">\r\n                            <mat-icon>edit</mat-icon>\r\n                        </button>\r\n                    }\r\n                    @if(delete_action) {\r\n                        <button mat-raised-button class=\"actionButton\" matTooltip=\"Eliminar\" [style]=\"{color: '#FF0000', padding: '12px'}\" (click)=\"delete_action.onClick(element)\">\r\n                            <mat-icon>delete</mat-icon>\r\n                        </button>\r\n                    }\r\n                </div>\r\n            </td>\r\n        </ng-container>\r\n    }\r\n\r\n    <tr mat-header-row *matHeaderRowDef=\"displayedColumns()\"></tr>\r\n    <tr mat-row *matRowDef=\"let row; columns: displayedColumns()\" [style]=\"{ background: tableConfig().rowBgColor?.(row) ?? '' }\"></tr>\r\n    <tr *matNoDataRow>\r\n      <td class=\"nodata\" [attr.colspan]=\"displayedColumns().length\">\r\n        @if(isLoading()) {\r\n            <span>Cargando...</span>\r\n        } @else {\r\n            <span>No se encontraron resultados</span>\r\n        }\r\n      </td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n<mat-paginator\r\n    #paginator\r\n    (page)=\"onPageChange($event)\"\r\n    [pageIndex]=\"tableConfig().paginatorOptions?.pageIndex\"\r\n    [pageSize]=\"tableConfig().paginatorOptions?.pageSize ?? 10\"\r\n    [pageSizeOptions]=\"tableConfig().paginatorOptions?.pageSizeOptions ?? [5, 10, 25, 100]\"\r\n    [length]=\"tableConfig().paginatorOptions?.length\"\r\n    showFirstLastButtons\r\n/>\r\n", styles: [".titleTable{font-weight:500;position:relative;margin-top:0}.overflowTable{overflow-x:auto;width:100%}.filtersContainer{width:100%;display:flex;align-items:center;flex-wrap:wrap;gap:1rem;margin:10px 0}.iconContainer{width:100%;display:flex;align-items:center}.actionsContainer{display:flex;align-items:center}.actionButton{min-width:inherit;padding:0 var(--mat-protected-button-horizontal-padding, 10px)}.actionButton mat-icon{margin:0}.maxEmail{color:#a55ec4;text-overflow:ellipsis;display:block;overflow:hidden;text-decoration:none}@media (max-width: 768px){.filtersContainer{flex-direction:column;align-items:unset}.filtersContainer>*{width:100%}}\n"], dependencies: [{ kind: "ngmodule", type: MatProgressBarModule }, { kind: "component", type: i1$3.MatProgressBar, selector: "mat-progress-bar", inputs: ["color", "value", "bufferValue", "mode"], outputs: ["animationEnd"], exportAs: ["matProgressBar"] }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "ngmodule", type: CommonModule }, { kind: "pipe", type: i2$2.UpperCasePipe, name: "uppercase" }, { kind: "pipe", type: i2$2.LowerCasePipe, name: "lowercase" }, { kind: "pipe", type: i2$2.JsonPipe, name: "json" }, { kind: "pipe", type: i2$2.DecimalPipe, name: "number" }, { kind: "pipe", type: i2$2.PercentPipe, name: "percent" }, { kind: "pipe", type: i2$2.TitleCasePipe, name: "titlecase" }, { kind: "pipe", type: i2$2.CurrencyPipe, name: "currency" }, { kind: "pipe", type: i2$2.DatePipe, name: "date" }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "component", type: EiffageFilter, selector: "eiffage-filter", inputs: ["value", "placeholder", "width"], outputs: ["queryChange", "keyEnter"] }, { kind: "ngmodule", type: MatTableModule }, { kind: "component", type: i4$1.MatTable, selector: "mat-table, table[mat-table]", exportAs: ["matTable"] }, { kind: "directive", type: i4$1.MatHeaderCellDef, selector: "[matHeaderCellDef]" }, { kind: "directive", type: i4$1.MatHeaderRowDef, selector: "[matHeaderRowDef]", inputs: ["matHeaderRowDef", "matHeaderRowDefSticky"] }, { kind: "directive", type: i4$1.MatColumnDef, selector: "[matColumnDef]", inputs: ["matColumnDef"] }, { kind: "directive", type: i4$1.MatCellDef, selector: "[matCellDef]" }, { kind: "directive", type: i4$1.MatRowDef, selector: "[matRowDef]", inputs: ["matRowDefColumns", "matRowDefWhen"] }, { kind: "directive", type: i4$1.MatHeaderCell, selector: "mat-header-cell, th[mat-header-cell]" }, { kind: "directive", type: i4$1.MatCell, selector: "mat-cell, td[mat-cell]" }, { kind: "component", type: i4$1.MatHeaderRow, selector: "mat-header-row, tr[mat-header-row]", exportAs: ["matHeaderRow"] }, { kind: "component", type: i4$1.MatRow, selector: "mat-row, tr[mat-row]", exportAs: ["matRow"] }, { kind: "directive", type: i4$1.MatNoDataRow, selector: "ng-template[matNoDataRow]" }, { kind: "ngmodule", type: MatPaginatorModule }, { kind: "component", type: i5$1.MatPaginator, selector: "mat-paginator", inputs: ["color", "pageIndex", "length", "pageSize", "pageSizeOptions", "hidePageSize", "showFirstLastButtons", "selectConfig", "disabled"], outputs: ["page"], exportAs: ["matPaginator"] }, { kind: "ngmodule", type: MatSortModule }, { kind: "directive", type: i6.MatSort, selector: "[matSort]", inputs: ["matSortActive", "matSortStart", "matSortDirection", "matSortDisableClear", "matSortDisabled"], outputs: ["matSortChange"], exportAs: ["matSort"] }, { kind: "component", type: i6.MatSortHeader, selector: "[mat-sort-header]", inputs: ["mat-sort-header", "arrowPosition", "start", "disabled", "sortActionDescription", "disableClear"], exportAs: ["matSortHeader"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i7.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i1$1.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "component", type: i1$1.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "component", type: i1$1.MatMiniFabButton, selector: "button[mat-mini-fab]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatBadgeModule }, { kind: "directive", type: i9.MatBadge, selector: "[matBadge]", inputs: ["matBadgeColor", "matBadgeOverlap", "matBadgeDisabled", "matBadgePosition", "matBadge", "matBadgeDescription", "matBadgeSize", "matBadgeHidden"] }, { kind: "ngmodule", type: MatCheckboxModule }, { kind: "component", type: i10.MatCheckbox, selector: "mat-checkbox", inputs: ["aria-label", "aria-labelledby", "aria-describedby", "aria-expanded", "aria-controls", "aria-owns", "id", "required", "labelPosition", "name", "value", "disableRipple", "tabIndex", "color", "disabledInteractive", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { kind: "ngmodule", type: MatMenuModule }, { kind: "component", type: i11.MatMenu, selector: "mat-menu", inputs: ["backdropClass", "aria-label", "aria-labelledby", "aria-describedby", "xPosition", "yPosition", "overlapTrigger", "hasBackdrop", "class", "classList"], outputs: ["closed", "close"], exportAs: ["matMenu"] }, { kind: "component", type: i11.MatMenuItem, selector: "[mat-menu-item]", inputs: ["role", "disabled", "disableRipple"], exportAs: ["matMenuItem"] }, { kind: "directive", type: i11.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", inputs: ["mat-menu-trigger-for", "matMenuTriggerFor", "matMenuTriggerData", "matMenuTriggerRestoreFocus"], outputs: ["menuOpened", "onMenuOpen", "menuClosed", "onMenuClose"], exportAs: ["matMenuTrigger"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffagePaginatedTable, decorators: [{
            type: Component,
            args: [{ selector: 'eiffage-paginated-table', imports: [
                        MatProgressBarModule,
                        MatFormFieldModule,
                        CommonModule,
                        MatIconModule,
                        EiffageFilter,
                        MatTableModule,
                        MatPaginatorModule,
                        MatSortModule,
                        MatTooltipModule,
                        MatButtonModule,
                        MatBadgeModule,
                        MatCheckboxModule,
                        MatMenuModule
                    ], template: "@if(tableConfig().title) {\r\n    <h3 class=\"titleTable\">{{ tableConfig().title }}</h3>\r\n}\r\n<div class=\"filtersContainer\">\r\n    @if(tableConfig().showFilter) {\r\n        <eiffage-filter\r\n            #tableFilter\r\n            [value]=\"tableConfig().filterValue\"\r\n            (queryChange)=\"applyFilter($event)\"\r\n            [placeholder]=\"tableConfig().filterPlaceholder || 'Buscar...'\"\r\n            [width]=\"tableConfig().filterWidth || 'width100'\"\r\n        />\r\n        @if(selections().length > 0) {\r\n            <button mat-mini-fab matTooltip=\"Limpiar seleccionados\" (click)=\"clearSelections()\">\r\n                <mat-icon>cleaning_services</mat-icon>\r\n            </button>\r\n        }\r\n    }\r\n    <ng-content />\r\n</div>\r\n<div class=\"overflowTable\">\r\n  @if (isLoading()) {\r\n  <mat-progress-bar mode=\"indeterminate\"></mat-progress-bar>\r\n  }\r\n  <table mat-table class=\"mat-elevation-z8\" [dataSource]=\"dataSource()\" matSort>\r\n\r\n    <!-- Selection -->\r\n     @if(tableConfig().selection) {\r\n        <ng-container matColumnDef=\"selection\">\r\n            <th mat-header-cell *matHeaderCellDef>\r\n                <mat-checkbox (change)=\"$event ? toggleAllRows() : null\"\r\n                    [checked]=\"isAllSelected()\"\r\n                    [indeterminate]=\"hasSomeSelected() && !isAllSelected()\"\r\n                    [aria-label]=\"checkboxLabel()\">\r\n                </mat-checkbox>\r\n            </th>\r\n            <td mat-cell *matCellDef=\"let element\">\r\n                @if(!tableConfig().hideSelection?.(element)) {\r\n                    <mat-checkbox (click)=\"$event.stopPropagation()\"\r\n                        (change)=\"$event ? toggleRow(element) : null\"\r\n                        [checked]=\"isRowSelected(element)\"\r\n                        [aria-label]=\"checkboxLabel(element)\">  \r\n                    </mat-checkbox>\r\n                }\r\n            </td>\r\n        </ng-container>\r\n     }\r\n    \r\n    <!-- Columns -->\r\n    @for(column of tableConfig().tableColumns; track column.key) {\r\n        <ng-container [matColumnDef]=\"column.key\" [sticky]=\"column?.stickyStart\" [stickyEnd]=\"column?.stickyEnd\">\r\n            <!-- Header cell definition -->\r\n            @if(column?.isSortable) {\r\n                <th mat-header-cell *matHeaderCellDef mat-sort-header>{{ column.displayedName }}</th>\r\n            } @else {\r\n                <th mat-header-cell *matHeaderCellDef>{{ column.displayedName }}</th>\r\n            }\r\n\r\n            <!-- Row cell definition -->\r\n            <!-- Button -->\r\n            @if(column?.button){\r\n                <td mat-cell *matCellDef=\"let element\">\r\n                    @if(column.button?.showButton && column.button?.showButton(element)) {\r\n                        @if(column.button?.icon && column.button?.text) {\r\n                            <!-- Icon Text Button -->\r\n                            <button mat-raised-button [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor }\" (click)=\"column.button?.onClick(element)\">\r\n                                <mat-icon [style]=\"{ color: column.button?.iconColor }\">{{ column.button?.icon }}</mat-icon>\r\n                                <span [style]=\"{ color: column.button?.textColor }\">{{ column.button?.text }}</span>\r\n                            </button>\r\n                        } @else if(column.button?.icon && !column.button?.text) {\r\n                            <!-- Icon Button -->\r\n                            <button mat-raised-button class=\"actionButton\" [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor, padding: '12px' }\" (click)=\"column.button?.onClick(element)\">\r\n                                <mat-icon [style]=\"{ color: column.button?.iconColor }\">{{ column.button?.icon }}</mat-icon>\r\n                            </button>\r\n                        } @else if(!column.button?.icon && column.button?.text) {\r\n                            <!-- Text Button -->\r\n                            <button mat-raised-button [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor }\" (click)=\"column.button?.onClick(element)\">\r\n                                <span [style]=\"{ color: column.button?.textColor }\">{{ column.button?.text }}</span>\r\n                            </button>\r\n                        }\r\n                    } @else if(!column.button?.showButton) {\r\n                        @if(column.button?.icon && column.button?.text) {\r\n                            <!-- Icon Text Button -->\r\n                            <button mat-raised-button [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor }\" (click)=\"column.button?.onClick(element)\">\r\n                                <mat-icon [style]=\"{ color: column.button?.iconColor }\">{{ column.button?.icon }}</mat-icon>\r\n                                <span [style]=\"{ color: column.button?.textColor }\">{{ column.button?.text }}</span>\r\n                            </button>\r\n                        } @else if(column.button?.icon && !column.button?.text) {\r\n                            <!-- Icon Button -->\r\n                            <button mat-icon-button [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor }\" (click)=\"column.button?.onClick(element)\">\r\n                                <mat-icon [style]=\"{ color: column.button?.iconColor }\">{{ column.button?.icon }}</mat-icon>\r\n                            </button>\r\n                        } @else if(!column.button?.icon && column.button?.text) {\r\n                            <!-- Text Button -->\r\n                            <button mat-raised-button [matTooltip]=\"column.button?.tooltip\" [style]=\"{ background: column.button?.bgColor }\" (click)=\"column.button?.onClick(element)\">\r\n                                <span [style]=\"{ color: column.button?.textColor }\">{{ column.button?.text }}</span>\r\n                            </button>\r\n                        }\r\n                    }\r\n                    <!-- @if(column.button?.showButton(element)) {\r\n                    } -->\r\n                </td>\r\n            } @else if(column.render) {\r\n                <td mat-cell *matCellDef=\"let element\" [innerHTML]=\"column.render(element, _tableService.getCellValue(element, column.key))\"></td>\"\r\n            } @else if(column?.icon) {\r\n                <td mat-cell *matCellDef=\"let element\">\r\n                    <div class=\"iconContainer\">\r\n                        <mat-icon [matTooltip]=\"column?.icon(element)?.tooltip\" [matBadge]=\"column?.icon(element)?.badge?.text\" [matBadgeSize]=\"column?.icon(element)?.badge?.size ?? 'medium'\" [style]=\"{ background: column?.icon(element)?.bgColor, color: column?.icon(element)?.iconColor }\" aria-hidden=\"false\" aria-label=\"Badge\">{{ column?.icon(element)?.icon }}</mat-icon>\r\n                        &nbsp;&nbsp;\r\n                        <span [style]=\"{ color: column?.icon(element)?.textColor }\">{{ column?.icon(element)?.text }}</span>\r\n                    </div>\r\n                </td>\r\n            } @else if(column?.menu) {\r\n                <td mat-cell *matCellDef=\"let element\">\r\n                    <button mat-icon-button [matMenuTriggerFor]=\"menu\" aria-label=\"Example icon-button with a menu\">\r\n                        <mat-icon>more_vert</mat-icon>\r\n                    </button>\r\n                    <mat-menu #menu=\"matMenu\" [yPosition]=\"column.menu?.yPosition ?? 'below'\" [xPosition]=\"column.menu?.xPosition ?? 'after'\">\r\n                        @for(item of column.menu?.items; track item) {\r\n                            <button mat-menu-item (click)=\"item.onClick(element)\" [disabled]=\"item.disabled\">\r\n                                @if(item.icon) {\r\n                                    <mat-icon>{{ item.icon }}</mat-icon>\r\n                                }\r\n                                <span>{{ item.text(element) }}</span>\r\n                            </button>\r\n                        }\r\n                    </mat-menu>\r\n                </td>\r\n            } @else if(column.href) {\r\n                <td mat-cell *matCellDef=\"let element\">\r\n                    @if(column?.href(element)) {\r\n                        <a class=\"maxEmail\" [href]=\"'mailto:'+column?.href(element)\" [matTooltip]=\"column?.href(element)\">{{ column?.href(element) }}</a>\r\n                    } @else {\r\n                        <span>-</span>\r\n                    }\r\n                </td>\r\n            }\r\n            @else {\r\n                <td mat-cell *matCellDef=\"let element\">\r\n                    <span [class.empty]=\"!(_tableService.getCellValue(element, column.key))\">\r\n                        @switch(column?.pipe?.name) {\r\n                            @case('date') {\r\n                                {{ _tableService.getCellValue(element, column.key) | date: column.pipe?.options ?? 'dd/MM/yyyy' }}\r\n                            }\r\n                            @case ('number') {\r\n                                {{ _tableService.getCellValue(element, column.key) | number : column.pipe?.options ?? \"1.0-0\"}}\r\n                            }\r\n                            @case ('currency') {\r\n                                {{ _tableService.getCellValue(element, column.key) | currency : column.pipe?.options ?? \"USD\"}}\r\n                            }\r\n                            @case ('json') {\r\n                                {{ _tableService.getCellValue(element, column.key) | json }}\r\n                            }\r\n                            @case ('lowercase') {\r\n                                {{ _tableService.getCellValue(element, column.key) | lowercase }}\r\n                            }\r\n                            @case ('uppercase') {\r\n                                {{ _tableService.getCellValue(element, column.key) | uppercase }}\r\n                            }\r\n                            @case ('titlecase') {\r\n                                {{ _tableService.getCellValue(element, column.key) | titlecase }}\r\n                            }\r\n                            @case ('percent') {\r\n                                {{ _tableService.getCellValue(element, column.key) | percent : column.pipe?.options ?? \"1.0-0\"}}\r\n                            }\r\n                            @default {\r\n                                {{ _tableService.getCellValue(element, column.key) ?? '-' }}\r\n                            }\r\n                        }\r\n                    </span>\r\n                </td>\r\n            }\r\n        </ng-container>\r\n    }\r\n\r\n    <!-- Actions -->\r\n    @if(add_action || details_action || edit_action || delete_action) {\r\n        <ng-container matColumnDef=\"actions\" [stickyEnd]=\"true\">\r\n            <th mat-header-cell *matHeaderCellDef>\r\n                @if(add_action) {\r\n                    <button mat-icon-button matTooltip=\"A\u00F1adir\" [style]=\"{color: '#4CAF50'}\" (click)=\"add_action.onClick()\">\r\n                        <mat-icon>add_circle</mat-icon>\r\n                    </button>\r\n                }\r\n            </th>\r\n            <td mat-cell *matCellDef=\"let element\">\r\n                <div class=\"actionsContainer\">\r\n                    @if(details_action) {\r\n                        <button mat-raised-button class=\"actionButton\" matTooltip=\"Ver detalle\" [style]=\"{color: '#005cbb', padding: '12px'}\" (click)=\"details_action.onClick(element)\">\r\n                            <mat-icon>search</mat-icon>\r\n                        </button>\r\n                    }\r\n                    @if(edit_action) {\r\n                        <button mat-raised-button class=\"actionButton\" matTooltip=\"Editar\" [style]=\"{color: '#FBC02D', padding: '12px'}\" (click)=\"edit_action.onClick(element)\">\r\n                            <mat-icon>edit</mat-icon>\r\n                        </button>\r\n                    }\r\n                    @if(delete_action) {\r\n                        <button mat-raised-button class=\"actionButton\" matTooltip=\"Eliminar\" [style]=\"{color: '#FF0000', padding: '12px'}\" (click)=\"delete_action.onClick(element)\">\r\n                            <mat-icon>delete</mat-icon>\r\n                        </button>\r\n                    }\r\n                </div>\r\n            </td>\r\n        </ng-container>\r\n    }\r\n\r\n    <tr mat-header-row *matHeaderRowDef=\"displayedColumns()\"></tr>\r\n    <tr mat-row *matRowDef=\"let row; columns: displayedColumns()\" [style]=\"{ background: tableConfig().rowBgColor?.(row) ?? '' }\"></tr>\r\n    <tr *matNoDataRow>\r\n      <td class=\"nodata\" [attr.colspan]=\"displayedColumns().length\">\r\n        @if(isLoading()) {\r\n            <span>Cargando...</span>\r\n        } @else {\r\n            <span>No se encontraron resultados</span>\r\n        }\r\n      </td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n<mat-paginator\r\n    #paginator\r\n    (page)=\"onPageChange($event)\"\r\n    [pageIndex]=\"tableConfig().paginatorOptions?.pageIndex\"\r\n    [pageSize]=\"tableConfig().paginatorOptions?.pageSize ?? 10\"\r\n    [pageSizeOptions]=\"tableConfig().paginatorOptions?.pageSizeOptions ?? [5, 10, 25, 100]\"\r\n    [length]=\"tableConfig().paginatorOptions?.length\"\r\n    showFirstLastButtons\r\n/>\r\n", styles: [".titleTable{font-weight:500;position:relative;margin-top:0}.overflowTable{overflow-x:auto;width:100%}.filtersContainer{width:100%;display:flex;align-items:center;flex-wrap:wrap;gap:1rem;margin:10px 0}.iconContainer{width:100%;display:flex;align-items:center}.actionsContainer{display:flex;align-items:center}.actionButton{min-width:inherit;padding:0 var(--mat-protected-button-horizontal-padding, 10px)}.actionButton mat-icon{margin:0}.maxEmail{color:#a55ec4;text-overflow:ellipsis;display:block;overflow:hidden;text-decoration:none}@media (max-width: 768px){.filtersContainer{flex-direction:column;align-items:unset}.filtersContainer>*{width:100%}}\n"] }]
        }], ctorParameters: () => [] });

class EiffageTemplateEditor {
    control = input.required(); // Control del formulario
    placeholder = input('Introduce el contenido del mensaje...'); // Placeholder del select opcional
    showSendButton = input(false); //
    isLoading = input(false); //
    sendEvent = output(); //
    onSendClick() {
        if (this.control().valid && this.showSendButton()) {
            this.sendEvent.emit();
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageTemplateEditor, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: EiffageTemplateEditor, isStandalone: true, selector: "eiffage-template-editor", inputs: { control: { classPropertyName: "control", publicName: "control", isSignal: true, isRequired: true, transformFunction: null }, placeholder: { classPropertyName: "placeholder", publicName: "placeholder", isSignal: true, isRequired: false, transformFunction: null }, showSendButton: { classPropertyName: "showSendButton", publicName: "showSendButton", isSignal: true, isRequired: false, transformFunction: null }, isLoading: { classPropertyName: "isLoading", publicName: "isLoading", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { sendEvent: "sendEvent" }, ngImport: i0, template: "<quill-editor [formControl]=\"control()\" [placeholder]=\"placeholder()\">\r\n    <div quill-editor-toolbar>\r\n        <div class=\"quill-container\">\r\n            <div>\r\n                <span class=\"ql-formats\">\r\n                    <button class=\"ql-bold\" [title]=\"'Negrita'\"></button>\r\n                    <button class=\"ql-italic\" [title]=\"'Cursiva'\"></button>\r\n                    <button class=\"ql-underline\" [title]=\"'Subrayado'\"></button>\r\n                </span>\r\n                <span class=\"ql-formats\">\r\n                    <select class=\"ql-align\" [title]=\"'Alinear'\">\r\n                    <option selected></option>\r\n                    <option value=\"center\"></option>\r\n                    <option value=\"right\"></option>\r\n                    <option value=\"justify\"></option>\r\n                    </select>\r\n                </span>\r\n                <span class=\"ql-formats\">\r\n                    <button class=\"ql-list\" value=\"ordered\" type=\"button\"></button>\r\n                </span>\r\n                <span class=\"ql-formats\">\r\n                    <button class=\"ql-link\" value=\"ordered\" type=\"button\"></button>\r\n                </span>\r\n            </div>\r\n            <div class=\"send-container\">\r\n                @if(showSendButton()) {\r\n                    <eiffage-loading-button buttonType=\"icon\" type=\"button\" [disabled]=\"control().invalid || isLoading()\" [loading]=\"isLoading()\" text=\"Enviar\" icon=\"send\" (onClick)=\"onSendClick()\" loadingColor=\"var(--primary)\" textColor=\"#000000\"></eiffage-loading-button>\r\n                }\r\n            </div>\r\n        </div>\r\n    </div>\r\n</quill-editor>", styles: [":host{display:block;width:100%}quill-editor{width:100%}.quill-container{align-items:center;display:flex;justify-content:space-between;margin-bottom:12px}.ql-editor{max-height:150px;overflow-y:auto}.send-container{display:flex;align-items:center;padding:0 12px;justify-content:flex-end}\n"], dependencies: [{ kind: "ngmodule", type: QuillModule }, { kind: "component", type: i1$4.QuillEditorComponent, selector: "quill-editor" }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: EiffageLoadingButton, selector: "eiffage-loading-button", inputs: ["buttonType", "loading", "loadingColor", "text", "textColor", "disabledTextColor", "icon", "iconColor", "color", "disabled", "type"], outputs: ["onClick"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageTemplateEditor, decorators: [{
            type: Component,
            args: [{ selector: 'eiffage-template-editor', imports: [
                        QuillModule,
                        ReactiveFormsModule,
                        MatButtonModule,
                        MatIconModule,
                        EiffageLoadingButton,
                    ], template: "<quill-editor [formControl]=\"control()\" [placeholder]=\"placeholder()\">\r\n    <div quill-editor-toolbar>\r\n        <div class=\"quill-container\">\r\n            <div>\r\n                <span class=\"ql-formats\">\r\n                    <button class=\"ql-bold\" [title]=\"'Negrita'\"></button>\r\n                    <button class=\"ql-italic\" [title]=\"'Cursiva'\"></button>\r\n                    <button class=\"ql-underline\" [title]=\"'Subrayado'\"></button>\r\n                </span>\r\n                <span class=\"ql-formats\">\r\n                    <select class=\"ql-align\" [title]=\"'Alinear'\">\r\n                    <option selected></option>\r\n                    <option value=\"center\"></option>\r\n                    <option value=\"right\"></option>\r\n                    <option value=\"justify\"></option>\r\n                    </select>\r\n                </span>\r\n                <span class=\"ql-formats\">\r\n                    <button class=\"ql-list\" value=\"ordered\" type=\"button\"></button>\r\n                </span>\r\n                <span class=\"ql-formats\">\r\n                    <button class=\"ql-link\" value=\"ordered\" type=\"button\"></button>\r\n                </span>\r\n            </div>\r\n            <div class=\"send-container\">\r\n                @if(showSendButton()) {\r\n                    <eiffage-loading-button buttonType=\"icon\" type=\"button\" [disabled]=\"control().invalid || isLoading()\" [loading]=\"isLoading()\" text=\"Enviar\" icon=\"send\" (onClick)=\"onSendClick()\" loadingColor=\"var(--primary)\" textColor=\"#000000\"></eiffage-loading-button>\r\n                }\r\n            </div>\r\n        </div>\r\n    </div>\r\n</quill-editor>", styles: [":host{display:block;width:100%}quill-editor{width:100%}.quill-container{align-items:center;display:flex;justify-content:space-between;margin-bottom:12px}.ql-editor{max-height:150px;overflow-y:auto}.send-container{display:flex;align-items:center;padding:0 12px;justify-content:flex-end}\n"] }]
        }] });

class EiffageToggleButton {
    options = input.required(); // Opciones del select
    label = input.required(); // Label del select
    value = input(); // Valor seleccionado del select
    multiple = input(false); // Si se puede seleccionar más de un valor
    changeEvent = output(); // Evento que se emite cuando se cambia el valor del select
    localValue = signal(null); // Valor local del select
    constructor() {
        effect(() => {
            this.initializeLocalValue();
        });
    }
    initializeLocalValue() {
        if (this.multiple()) {
            const valueArray = Array.isArray(this.value())
                ? this.value()
                : this.value() !== undefined ? [this.value()] : [];
            this.localValue.set(valueArray);
        }
        else {
            this.localValue.set(this.value() ?? null);
        }
    }
    onChange(option) {
        if (this.multiple()) {
            const currentValue = this.localValue();
            if (currentValue.includes(option.value)) {
                this.localValue.set(currentValue.filter(value => value !== option.value));
                this.changeEvent.emit(this.options().filter(option => this.localValue()?.includes(option.value)) ?? []);
                return;
            }
            this.localValue.set([...currentValue, option.value]);
            this.changeEvent.emit(this.options().filter(option => this.localValue()?.includes(option.value)) ?? []);
        }
        else {
            if (this.localValue() === option.value) {
                this.localValue.set(null);
                this.changeEvent.emit(null);
                return;
            }
            this.localValue.set(option.value);
            this.changeEvent.emit(option);
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageToggleButton, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.0.5", type: EiffageToggleButton, isStandalone: true, selector: "eiffage-toggle-button", inputs: { options: { classPropertyName: "options", publicName: "options", isSignal: true, isRequired: true, transformFunction: null }, label: { classPropertyName: "label", publicName: "label", isSignal: true, isRequired: true, transformFunction: null }, value: { classPropertyName: "value", publicName: "value", isSignal: true, isRequired: false, transformFunction: null }, multiple: { classPropertyName: "multiple", publicName: "multiple", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { changeEvent: "changeEvent" }, ngImport: i0, template: "<div class=\"toggle-button-container\">\r\n  <mat-button-toggle-group [value]=\"localValue()\" [multiple]=\"multiple()\">\r\n    @for (option of options(); track option.value) {\r\n        <mat-button-toggle [value]=\"option.value\" (click)=\"onChange(option)\">{{ option.label }}</mat-button-toggle>\r\n    }\r\n  </mat-button-toggle-group>\r\n  <span class=\"toggle-button-label\">{{ label() }}</span>\r\n</div>", styles: [".toggle-button-container{display:flex;align-items:center;gap:.5rem}\n"], dependencies: [{ kind: "ngmodule", type: MatButtonToggleModule }, { kind: "directive", type: i1$5.MatButtonToggleGroup, selector: "mat-button-toggle-group", inputs: ["appearance", "name", "vertical", "value", "multiple", "disabled", "disabledInteractive", "hideSingleSelectionIndicator", "hideMultipleSelectionIndicator"], outputs: ["valueChange", "change"], exportAs: ["matButtonToggleGroup"] }, { kind: "component", type: i1$5.MatButtonToggle, selector: "mat-button-toggle", inputs: ["aria-label", "aria-labelledby", "id", "name", "value", "tabIndex", "disableRipple", "appearance", "checked", "disabled", "disabledInteractive"], outputs: ["change"], exportAs: ["matButtonToggle"] }, { kind: "ngmodule", type: CommonModule }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.5", ngImport: i0, type: EiffageToggleButton, decorators: [{
            type: Component,
            args: [{ selector: 'eiffage-toggle-button', imports: [
                        MatButtonToggleModule,
                        CommonModule
                    ], template: "<div class=\"toggle-button-container\">\r\n  <mat-button-toggle-group [value]=\"localValue()\" [multiple]=\"multiple()\">\r\n    @for (option of options(); track option.value) {\r\n        <mat-button-toggle [value]=\"option.value\" (click)=\"onChange(option)\">{{ option.label }}</mat-button-toggle>\r\n    }\r\n  </mat-button-toggle-group>\r\n  <span class=\"toggle-button-label\">{{ label() }}</span>\r\n</div>", styles: [".toggle-button-container{display:flex;align-items:center;gap:.5rem}\n"] }]
        }], ctorParameters: () => [] });

/*
 * Public API Surface of eiffage-material-ui
 */
/**
 * Eiffage Material UI
 */
/**
 * Components
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ActionButtonType, EiffageBasicSelect, EiffageConfirmDialog, EiffageFilter, EiffageInfoDialog, EiffageLoadingButton, EiffagePaginatedSelect, EiffagePaginatedTable, EiffageTemplateEditor, EiffageToggleButton, TableService, base64ToUtf8, includeNoSensible };
//# sourceMappingURL=eiffage-material-ui.mjs.map
