import { AfterViewInit, OnDestroy } from '@angular/core';
import { FormControl } from '@angular/forms';
import { Observable } from 'rxjs';
import { PaginationFilter } from '../../models/pagination-filter';
import { PaginatedDropdownOptions } from '../../models/paginated-dropdown-options';
import * as i0 from "@angular/core";
interface ErrorForm {
    name: 'required' | 'minlength' | 'maxlength' | 'pattern' | 'email' | 'min' | 'max' | 'unique' | 'custom';
    message: string;
}
export declare class EiffagePaginatedSelect<T> implements OnDestroy, AfterViewInit {
    readonly label: import("@angular/core").InputSignal<string>;
    readonly options$: import("@angular/core").InputSignal<Observable<PaginatedDropdownOptions<T>>>;
    readonly control: import("@angular/core").InputSignal<FormControl<any>>;
    readonly valueKey: import("@angular/core").InputSignal<string>;
    readonly labelKey: import("@angular/core").InputSignal<(option: T) => string>;
    readonly placeholder: import("@angular/core").InputSignal<string>;
    readonly multiple: import("@angular/core").InputSignal<boolean>;
    readonly clearable: import("@angular/core").InputSignal<boolean>;
    readonly errors: import("@angular/core").InputSignal<ErrorForm[]>;
    readonly selectionChange: import("@angular/core").OutputEmitterRef<T>;
    readonly updateOptions: import("@angular/core").OutputEmitterRef<PaginationFilter>;
    private searchInput;
    private subscriptionOptions;
    private subscriptionValueChange;
    protected unduplicatedSelections: import("@angular/core").WritableSignal<T[]>;
    filter: import("@angular/core").WritableSignal<PaginationFilter>;
    options: import("@angular/core").WritableSignal<T[]>;
    total: import("@angular/core").WritableSignal<number>;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    private initializeData;
    getValue(option: T): T[keyof T];
    getLabel(option: T): string;
    openedChange(opened: boolean): void;
    clearInput(): void;
    onClearSelect(): void;
    onSelectionChange(item: T): void;
    onQueryChange(): void;
    onSeeMore(): void;
    compareWith: (option: T, selected: T) => boolean;
    getErrorMessage(): string;
    private includeSelectedOptions;
    selectedInOptions(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<EiffagePaginatedSelect<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EiffagePaginatedSelect<any>, "eiffage-paginated-select", never, { "label": { "alias": "label"; "required": true; "isSignal": true; }; "options$": { "alias": "options$"; "required": true; "isSignal": true; }; "control": { "alias": "control"; "required": true; "isSignal": true; }; "valueKey": { "alias": "valueKey"; "required": true; "isSignal": true; }; "labelKey": { "alias": "labelKey"; "required": true; "isSignal": true; }; "placeholder": { "alias": "placeholder"; "required": false; "isSignal": true; }; "multiple": { "alias": "multiple"; "required": false; "isSignal": true; }; "clearable": { "alias": "clearable"; "required": false; "isSignal": true; }; "errors": { "alias": "errors"; "required": false; "isSignal": true; }; }, { "selectionChange": "selectionChange"; "updateOptions": "updateOptions"; }, never, never, true, never>;
}
export {};
