import { OnDestroy, OnInit } from '@angular/core';
import { MatSort } from '@angular/material/sort';
import { MatTableDataSource } from '@angular/material/table';
import { MatPaginator, PageEvent } from '@angular/material/paginator';
import { ActionButton, ActionButtonType, TableConfig } from '../../models/table-config';
import { TableService } from '../../services/table.service';
import { SelectionModel } from '@angular/cdk/collections';
import * as i0 from "@angular/core";
export declare class EiffagePaginatedTable<T> implements OnInit, OnDestroy {
    _tableService: TableService;
    readonly tableData: import("@angular/core").InputSignal<T[]>;
    tableConfig: import("@angular/core").InputSignal<TableConfig>;
    readonly isLoading: import("@angular/core").InputSignal<boolean>;
    ActionButtonType: typeof ActionButtonType;
    readonly pageChangeEvent: import("@angular/core").OutputEmitterRef<PageEvent>;
    readonly filterEvent: import("@angular/core").OutputEmitterRef<string>;
    readonly selectionEvent: import("@angular/core").OutputEmitterRef<T[]>;
    private filterSubject;
    add_action: ActionButton | null;
    details_action: ActionButton | null;
    edit_action: ActionButton | null;
    delete_action: ActionButton | null;
    readonly displayedColumns: import("@angular/core").WritableSignal<string[]>;
    readonly dataSource: import("@angular/core").WritableSignal<MatTableDataSource<T, MatPaginator>>;
    readonly selection: import("@angular/core").WritableSignal<SelectionModel<T>>;
    readonly selections: import("@angular/core").WritableSignal<T[]>;
    readonly sort: import("@angular/core").Signal<MatSort>;
    readonly paginator: import("@angular/core").Signal<MatPaginator>;
    constructor();
    ngOnInit(): void;
    ngOnDestroy(): void;
    private initializeData;
    private getDisplayedColumns;
    applyFilter(filteredValue: string): void;
    onPageChange(event: PageEvent): void;
    isRowSelected(row: T): boolean;
    areRowsEqual(rowA: T, rowB: T): boolean;
    isAllSelected(): boolean;
    hasSomeSelected(): boolean;
    toggleAllRows(): void;
    checkboxLabel(row?: T): string;
    toggleRow(row: T): void;
    onSelectionChange(): void;
    clearSelections(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EiffagePaginatedTable<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EiffagePaginatedTable<any>, "eiffage-paginated-table", never, { "tableData": { "alias": "tableData"; "required": true; "isSignal": true; }; "tableConfig": { "alias": "tableConfig"; "required": true; "isSignal": true; }; "isLoading": { "alias": "isLoading"; "required": true; "isSignal": true; }; }, { "pageChangeEvent": "pageChangeEvent"; "filterEvent": "filterEvent"; "selectionEvent": "selectionEvent"; }, never, ["*"], true, never>;
}
